
#' @title Optimization of solar panel alignment
#'
#' @description  Sum of the power generated by a solar panel in dependence of tilt and rotation
#' Is used only to optimize tilt and rotation of the surface
#'
#' @param param  parameters to be fitted: Tilt (from panel to ground [Rad])[1] and rotation (south = 0°,clockwise [Rad]) [2] of the solar panel
#' @param lat latitude [Rad]
#' @param lon longitude [Rad]
#' @param I0 measured global radiation [W/m^2]
#' @param declination Declination [Rad]
#' @param angle_change_per_sec angle change per second (function) [Rad]
#' @param cos_zenith Cosinus of zenith of the sun (function)
#' @return summed up power over the time of measurment [W/m^2] (one value)
#'
#' @export

Power <- function(param,lat,lon,I0,declination,angle_speed,cos_zenith,debug=FALSE) {
  tilt = param[1]
  rot = param[2]

  I<-I0*fast_cos_incidence(lat,lon,tilt,rot,declination,angle_speed)/cos_zenith
  if(debug) cat("Power",sum(I==0),"\n")

  I <- pmax(I,0)
  if(debug) cat("Power <0",sum(I==0),"\n")

  total= sum(I,na.rm=TRUE)
  if(debug) cat("summed up:",total,"\n")

  return(total)
}

#' optimization of orientation of the solar panel
#'
#' In the function optim is used to optimize the parameters by maximising the power function. The starting value is 0 in both parameters which describes a horizontal surface.
#'
#' @param time time interval of measurement [asPOSIXct]
#' @param lat latitude [Rad]
#' @param lon longitude [Rad]
#' @param I0 measured global radiation [W/m^2]
#'
#' @return angle of optimized tilt [1] and rotation [2] [Rad]

#' @examples
#' optim_angle(time= mydata$time,lat=45*pi/180,lon=8*pi/180,I0 = mydata$radiation)
#'
#' @export
#'
optim_angle<- function(time,lat,lon,I0,debug=FALSE){

  angle_speed <-angle_per_second(time=time,lon=lon,debug=debug)

  dec <- declination(time=time)

  cos_zenith <- cos_incidence(lat=lat,lon=lon,time=time,tilt=0,rot=0)

  cos_zenith[cos_zenith <=0.01] = NA

  tilt_rot <- optim(
    control=list(fnscale=-1), # maximize instead of minimize
    par=c(0,0), # starting value
    fn=Power, # function to optimize
    # arguments to the function
    lat=lat,
    lon=lon,
    I0 = I0,
    dec = dec,
    angle_speed = angle_speed,
    cos_zenith = cos_zenith,
    debug=TRUE
  )
  return(tilt_rot)
}
